// Generated by CoffeeScript 1.6.3
(function() {
  var DEEPIN_ITEM_ID, INVALID_IMG, ajax, array_sort_min2max, assert, bindtextdomain, build_menu, calc_text_size, clamp, create_element, create_img, dnd_is_deepin_item, dnd_is_desktop, dnd_is_file, echo, find_drag_target, getRandomInt, get_dbus, get_default_application_icon, get_function_name, get_page_xy, get_path_base, get_path_name, inject_css, inject_js, main, remove_element, run_callback_after_prop_changed, run_post, sortNumber, swap_element, _,
    __hasProp = {}.hasOwnProperty;

  RegExp.escape = function(text) {
    return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
  };

  Storage.prototype.setObject = function(key, value) {
    return this.setItem(key, JSON.stringify(value));
  };

  Storage.prototype.getObject = function(key) {
    return JSON.parse(this.getItem(key));
  };

  String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
  };

  String.prototype.args = function() {
    var i, len, o, _i;
    o = this;
    len = arguments.length;
    for (i = _i = 1; 1 <= len ? _i <= len : _i >= len; i = 1 <= len ? ++_i : --_i) {
      o = o.replace(new RegExp("%" + i, "g"), "" + arguments[i - 1]);
    }
    return o;
  };

  String.prototype.isPath = function() {
    return this.indexOf("/") !== -1;
  };

  String.prototype.isDataURLImage = function() {
    return this.match(/^data:image\/.+(;base64)?,/);
  };

  String.prototype.addSlashes = function() {
    return this.replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
  };

  Array.prototype.remove = function(el) {
    var i;
    i = this.indexOf(el);
    if (i !== -1) {
      return this.splice(this.indexOf(el), 1)[0];
    }
  };

  echo = function(log) {
    return console.log(log);
  };

  assert = function(value, msg) {
    if (!value) {
      throw new Error(msg);
    }
  };

  _ = function(s, d) {
    if (d) {
      return DCore.dgettext(d, s);
    } else {
      return DCore.gettext(s);
    }
  };

  bindtextdomain = function(domain, locale_dir) {
    return DCore.bindtextdomain(domain, locale_dir);
  };

  build_menu = function(info) {
    var i, item, len, menu, submenu, submenu_count, v, _i;
    len = info.length;
    if (len < 2) {
      return null;
    }
    submenu_count = 10000;
    menu = new Menu(info[0]);
    for (i = _i = 1; 1 <= len ? _i < len : _i > len; i = 1 <= len ? ++_i : --_i) {
      v = info[i];
      if (v.length === 0) {
        menu.addSeparator();
      } else if (typeof v[0] === "number") {
        item = new MenuItem(v[0], v[1]);
        if (v[2] != null) {
          item.setActive(v[2]);
        }
        menu.append(item);
      } else {
        echo("submenu id:" + submenu_count + ",and text:" + v[0]);
        item = new MenuItem(submenu_count, v[0]);
        if (v[2] != null) {
          item.setActive(v[2]);
        }
        submenu = build_menu(v[1]);
        item.setSubMenu(submenu);
        menu.append(item);
        submenu_count += 1;
      }
    }
    return menu;
  };

  get_page_xy = function(el, x, y) {
    var p;
    if (x == null) {
      x = 0;
    }
    if (y == null) {
      y = 0;
    }
    return p = webkitConvertPointFromNodeToPage(el, new WebKitPoint(x, y));
  };

  find_drag_target = function(el) {
    var p;
    p = el;
    if (p.draggable) {
      return p;
    }
    while (p = p.parentNode) {
      if (p.draggable) {
        return p;
      }
    }
    return null;
  };

  swap_element = function(c1, c2) {
    var tmp;
    if (c1.parentNode === c2.parentNode) {
      tmp = document.createElement('div');
      c1.parentNode.insertBefore(tmp, c1);
      c2.parentNode.insertBefore(c1, c2);
      tmp.parentNode.insertBefore(c2, tmp);
      return tmp.parentNode.removeChild(tmp);
    }
  };

  document.body.ondrop = function(e) {
    return e.preventDefault();
  };

  run_post = function(f, self) {
    var f2;
    f2 = f.bind(self || this);
    return setTimeout(f2, 0);
  };

  create_element = function(opt, parent, compatible) {
    var el, k, v;
    if (typeof compatible !== 'undefined' || typeof parent === 'string') {
      opt = {
        tag: opt,
        "class": parent
      };
      parent = compatible;
    }
    if (opt.tag == null) {
      return null;
    }
    el = document.createElement(opt.tag);
    delete opt.tag;
    for (k in opt) {
      if (!__hasProp.call(opt, k)) continue;
      v = opt[k];
      el.setAttribute(k, v);
    }
    if (parent) {
      parent.appendChild(el);
    }
    return el;
  };

  create_img = function(opt, parent, compatible) {
    var el;
    if (typeof compatible !== 'undefined') {
      opt = {
        "class": opt,
        src: parent
      };
      parent = compatible;
    }
    opt.tag = 'img';
    el = create_element(opt, parent);
    el.draggable = false;
    return el;
  };

  calc_text_size = function(txt, width) {
    var h, tmp;
    tmp = create_element('div', 'hidden_calc_text', document.body);
    tmp.innerText = txt;
    tmp.style.width = "" + width + "px";
    h = tmp.clientHeight;
    document.body.removeChild(tmp);
    return h;
  };

  clamp = function(value, min, max) {
    if (value < min) {
      return min;
    }
    if (value > max) {
      return max;
    }
    return value;
  };

  get_function_name = function() {
    if (!arguments.caller) {
      return "AnymouseFunction";
    }
    return /function (.*?)\(/.exec(arguments.caller.toString())[1];
  };

  DEEPIN_ITEM_ID = "deepin-item-id";

  dnd_is_desktop = function(e) {
    return e.dataTransfer.getData("text/uri-list").trim().endsWith(".desktop");
  };

  dnd_is_deepin_item = function(e) {
    if (e.dataTransfer.getData(DEEPIN_ITEM_ID)) {
      return true;
    } else {
      return false;
    }
  };

  dnd_is_file = function(e) {
    return e.dataTransfer.getData("text/uri-list").length !== 0;
  };

  ajax = function(url, sync, callback, callback_error) {
    var xhr;
    if (sync == null) {
      sync = true;
    }
    xhr = new XMLHttpRequest();
    xhr.open("GET", url, sync);
    xhr.onload = function() {
      echo("XMLHttpRequest onload");
      if (typeof callback === "function") {
        callback(xhr);
      }
    };
    xhr.onerror = function() {
      echo("XMLHttpRequest onerror");
      return typeof callback_error === "function" ? callback_error(xhr) : void 0;
    };
    return xhr.send(null);
  };

  get_path_base = function(path) {
    return path.split('/').slice(0, -1).join('/');
  };

  get_path_name = function(path) {
    var dot_pos;
    dot_pos = path.lastIndexOf('.');
    if (dot_pos === -1) {
      return path.substring(path.lastIndexOf('/') + 1);
    } else {
      return path.substring(path.lastIndexOf('/') + 1, dot_pos);
    }
  };

  remove_element = function(obj) {
    var _parentElement;
    _parentElement = obj != null ? obj.parentNode : void 0;
    return _parentElement != null ? _parentElement.removeChild(obj) : void 0;
  };

  sortNumber = function(a, b) {
    return a - b;
  };

  array_sort_min2max = function(arr) {
    return arr.sort(sortNumber);
  };

  inject_js = function(src) {
    var js_element;
    js_element = create_element("script", null, document.body);
    return js_element.src = src;
  };

  inject_css = function(el, src) {
    var css_element;
    css_element = create_element('link', null, el);
    css_element.rel = "stylesheet";
    return css_element.href = src;
  };

  get_dbus = function(type, opt, testProperty) {
    var count, d, dbusArg, e, func;
    if (!testProperty) {
      throw "get_dbus requires 3 arguments";
    }
    type = type.toLowerCase();
    if (type === "system") {
      type = "sys";
    }
    if (typeof opt === 'string') {
      dbusArg = [opt];
      func = DCore.DBus[type];
    } else {
      dbusArg = [opt.name, opt.path, opt["interface"]];
      func = DCore.DBus["" + type + "_object"];
    }
    d = null;
    try {
      d = func.apply(null, dbusArg);
    } catch (_error) {
      e = _error;
      if (typeof opt === 'string') {
        throw "Get DBus \"" + opt + "\" failed: " + e;
      } else {
        throw "Get DBus \"" + opt.name + " " + opt.path + " " + opt["interface"] + "\" failed: " + e;
      }
    }
    if (!d) {
      if (typeof opt === 'string') {
        throw "Get DBus \"" + opt + "\" failed";
      } else {
        throw "Get DBus \"" + opt.name + " " + opt.path + " " + opt["interface"] + "\" failed";
      }
    }
    count = 0;
    while (d && !d[testProperty]) {
      try {
        d = func.apply(null, dbusArg);
        count += 1;
        if (count === 100) {
          if (typeof opt === 'string') {
            throw "Get DBus \"" + opt + "\" failed";
          } else {
            throw "Get DBus \"" + opt.name + " " + opt.path + " " + opt["interface"] + "\" failed";
          }
        }
      } catch (_error) {}
    }
    if (!d) {
      if (typeof opt === 'string') {
        throw "Get DBus \"" + opt + "\" failed";
      } else {
        throw "Get DBus \"" + opt.name + " " + opt.path + " " + opt["interface"] + "\" failed";
      }
    }
    return d;
  };

  getRandomInt = function(min, max) {
    var c;
    c = max - min + 1;
    return Math.floor(Math.random() * c + min);
  };

  run_callback_after_prop_changed = function(callback, init_value, get_prop_func, interval, duration, timeout_callback) {
    var runner;
    if (init_value !== get_prop_func()) {
      callback();
      return;
    }
    runner = function(elapsed) {
      if (init_value !== get_prop_func()) {
        return callback();
      } else {
        elapsed = elapsed + interval;
        if (elapsed < duration) {
          return setTimeout(function() {
            return runner(elapsed);
          }, interval);
        } else {
          return typeof timeout_callback === "function" ? timeout_callback() : void 0;
        }
      }
    };
    callback();
    return runner(interval);
  };

  INVALID_IMG = "application-default-icon";

  get_default_application_icon = function(size) {
    return DCore.get_theme_icon(INVALID_IMG, size) || ("../common/image/" + INVALID_IMG + ".png");
  };

  main = function() {
    var lowpower, lp_full, _b,
      _this = this;
    _b = document.body;
    _b.addEventListener("contextmenu", function(e) {
      e.preventDefault();
      return e.stopPropagation();
    });
    setInterval(function() {
      return DCore.Lowpower.restack();
    }, 50);
    lp_full = create_element("div", "lp_full", _b);
    lowpower = create_element("div", "lowpower", lp_full);
    lowpower.style.width = "157px";
    lowpower.style.height = "97px";
    lowpower.style.backgroundImage = "url(img/lowpower.png)";
    return lowpower.style.display = "block";
  };

  DCore.signal_connect('primary_size_changed', function(alloc) {
    echo("primary_size_changed:" + alloc.x + "," + alloc.y + "," + alloc.width + "," + alloc.height);
    document.body.style.position = "absolute";
    document.body.style.left = alloc.x;
    document.body.style.top = alloc.y;
    document.body.style.height = alloc.height;
    document.body.style.width = alloc.width;
    return main();
  });

  DCore.Lowpower.emit_webview_ok();

}).call(this);
